import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsLangLog, CmsLangLogParam } from './model';

/**
 * 分页查询国际化记录启用
 */
export async function pageCmsLangLog(params: CmsLangLogParam) {
  const res = await request.get<ApiResult<PageResult<CmsLangLog>>>(
    '/cms/cms-lang-log/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询国际化记录启用列表
 */
export async function listCmsLangLog(params?: CmsLangLogParam) {
  const res = await request.get<ApiResult<CmsLangLog[]>>(
    '/cms/cms-lang-log',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加国际化记录启用
 */
export async function addCmsLangLog(data: CmsLangLog) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-lang-log',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改国际化记录启用
 */
export async function updateCmsLangLog(data: CmsLangLog) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-lang-log',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除国际化记录启用
 */
export async function removeCmsLangLog(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-lang-log/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除国际化记录启用
 */
export async function removeBatchCmsLangLog(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-lang-log/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询国际化记录启用
 */
export async function getCmsLangLog(id: number) {
  const res = await request.get<ApiResult<CmsLangLog>>(
    '/cms/cms-lang-log/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
